add options for options xr, ar, turbo, mcast_rate Signed-off-by: Lorenz Schori <loren...
[openwrt/svn-archive/archive.git] / package / madwifi / files / lib / wifi / madwifi.sh
index 569c96e710c247195a26f5b48fde425217ac028f..ca933a1ddd1f3f6c14b0a4060d944592e04ae95a 100755 (executable)
@@ -1,5 +1,4 @@
 #!/bin/sh
-set -x
 append DRIVERS "atheros"
 
 scan_atheros() {
@@ -15,34 +14,49 @@ scan_atheros() {
                
                config_get mode "$vif" mode
                case "$mode" in
-                       adhoc|sta|ap)
+                       adhoc|ahdemo|sta|ap)
                                append $mode "$vif"
                        ;;
                        wds)
                                config_get addr "$vif" bssid
-                               ${addr:+append wds "$addr"}
+                               config_get ssid "$vif" ssid
+                               [ -z "$addr" -a -n "$ssid" ] && {
+                                       config_set "$vif" wds 1
+                                       config_set "$vif" mode sta
+                                       mode="sta"
+                                       addr="$ssid"
+                               }
+                               ${addr:+append $mode "$vif"}
                        ;;
                        *) echo "$device($vif): Invalid mode, ignored."; continue;;
                esac
        done
 
-       case "${adhoc:+1}:${sta:+}:${ap+1}" in
+       case "${adhoc:+1}:${sta:+1}:${ap+1}" in
                # valid mode combinations
-               1::);;
+               1::) wds="";;
+               1::1);;
                :1:1)config_set "$device" nosbeacon 1;; # AP+STA, can't use beacon timers for STA
                :1:);;
                ::1);;
-               :::);;
+               ::);;
                *) echo "$device: Invalid mode combination in config"; return 1;;
        esac
 
-       config_set "$device" vifs "${ap:+$ap }${adhoc:+$adhoc }${sta:+$sta }"
-       
-       [ -z "$adhoc" ] && config_set "$device" wds "$wdsifs"
+       config_set "$device" vifs "${ap:+$ap }${adhoc:+$adhoc }${ahdemo:+$ahdemo }${sta:+$sta }${wds:+$wds }"
 }
 
+
 disable_atheros() (
        local device="$1"
+
+       set_wifi_down "$device"
+       # kill all running hostapd and wpa_supplicant processes that
+       # are running on atheros vifs 
+       for pid in `pidof hostapd wpa_supplicant`; do
+               grep ath /proc/$pid/cmdline >/dev/null && \
+                       kill $pid
+       done
        
        include /lib/network
        cd /proc/sys/net
@@ -50,16 +64,18 @@ disable_atheros() (
                grep "$device" "$dev/%parent" >/dev/null 2>/dev/null && {
                        ifconfig "$dev" down 
                        unbridge "$dev"
-                       wlanconfig $dev destroy
+                       wlanconfig "$dev" destroy
                }
        done
+       return 0
 )
 
 enable_atheros() {
+       local device="$1"
        config_get channel "$device" channel
-       config_get wds "$device" wds
        config_get vifs "$device" vifs
-
+       
+       local first=1
        for vif in $vifs; do
                nosbeacon=
                config_get ifname "$vif" ifname
@@ -70,12 +86,46 @@ enable_atheros() {
                
                config_get ifname "$vif" ifname
                ifname=$(wlanconfig "$ifname" create wlandev "$device" wlanmode "$mode" ${nosbeacon:+nosbeacon})
-               config_set "$vif" ifname "$ifname"
-               
                [ $? -ne 0 ] && {
-                       echo "enable_atheros($device): Failed to set up vif $ifname" >&2
+                       echo "enable_atheros($device): Failed to set up $mode vif $ifname" >&2
                        continue
                }
+               config_set "$vif" ifname "$ifname"
+
+               [ "$first" = 1 ] && {
+                       # only need to change freq band and channel on the first vif
+                       config_get agmode "$device" agmode
+                       pureg=0
+                       case "$agmode" in
+                               *b) agmode=11b;;
+                               *bg) agmode=11g;;
+                               *g) agmode=11g; pureg=1;;
+                               *a) agmode=11a;;
+                               *) agmode=auto;;
+                       esac
+                       iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null 
+                       ifconfig "$ifname" up
+                       sleep 1
+                       iwpriv "$ifname" mode "$agmode"
+                       iwpriv "$ifname" pureg "$pureg"
+                       iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null 
+               }
+       
+               config_get_bool hidden "$vif" hidden 0
+               iwpriv "$ifname" hide_ssid "$hidden"
+
+               config_get ff "$vif" ff
+               if [ -n "$ff" ]; then
+                       iwpriv "$ifname" ff "$ff"
+               fi
+
+               config_get wds "$vif" wds
+               case "$wds" in
+                       1|on|enabled) wds=1;;
+                       *) wds=0;;
+               esac
+               iwpriv "$ifname" wds "$wds"
+
                wpa=
                case "$enc" in
                        WEP|wep)
@@ -84,49 +134,173 @@ enable_atheros() {
                                        iwconfig "$ifname" enc "[$idx]" "${key:-off}"
                                done
                                config_get key "$vif" key
-                               iwconfig "$ifname" enc "$key"
+                               key="${key:-1}"
+                               case "$key" in
+                                       [1234]) iwconfig "$ifname" enc "[$key]";;
+                                       *) iwconfig "$ifname" enc "$key";;
+                               esac
+                       ;;
+                       PSK|psk|PSK2|psk2)
+                               config_get key "$vif" key
                        ;;
                esac
+
                case "$mode" in
-                       ap)
-                               local hostapd_cfg=
-                               case "$enc" in
-                                       *psk*|*PSK*)
-                                       # FIXME: wpa
-                                       ;;
-                                       *wpa*|*WPA*)
-                                       # FIXME: add wpa+radius here
-                                       ;;
-                               esac
+                       wds)
+                               config_get addr "$vif" bssid
+                               iwpriv "$ifname" wds_add "$addr"
                        ;;
-                       sta)
-                               # FIXME: implement wpa_supplicant calls here
+                       adhoc|ahdemo)
+                               config_get addr "$vif" bssid
+                               [ -z "$addr" ] || { 
+                                       iwconfig "$ifname" ap "$addr"
+                               }
                        ;;
-               esac    
-               
+               esac
                config_get ssid "$vif" ssid
-               append if_up "iwconfig $ifname essid $ssid channel $channel" ";$N"
-               append if_up "sleep 1" ";$N"
-               append if_up "ifconfig $ifname up" ";$N"
-               
+
+               config_get_bool bgscan "$vif" bgscan
+               [ -n "$bgscan" ] && iwpriv "$ifname" bgscan "$bgscan"
+
+               config_get_bool antdiv "$device" diversity
+               [ -n "$antdiv" ] && sysctl -w dev."$device".diversity="$antdiv" >&-
+
+               config_get antrx "$device" rxantenna
+               [ -n "$antrx" ] && sysctl -w dev."$device".rxantenna="$antrx" >&-
+
+               config_get anttx "$device" txantenna
+               [ -n "$anttx" ] && sysctl -w dev."$device".txantenna="$anttx" >&-
+
+               config_get distance "$device" distance
+               [ -n "$distance" ] && athctrl -i "$device" -d "$distance" >&-
+
+               config_get txpwr "$vif" txpower
+               [ -n "$txpwr" ] && iwconfig "$ifname" txpower "${txpwr%%.*}"
+
+               config_get rate "$vif" rate
+               [ -n "$rate" ] && iwconfig "$ifname" rate "${rate%%.*}"
+
+               config_get mcast_rate "$vif" mcast_rate
+               [ -n "$mcast_rate" ] && iwpriv "$ifname" mcast_rate "${mcast_rate%%.*}"
+
+               config_get frag "$vif" frag
+               [ -n "$frag" ] && iwconfig "$ifname" frag "${frag%%.*}"
+
+               config_get rts "$vif" rts
+               [ -n "$rts" ] && iwconfig "$ifname" rts "${rts%%.*}"
+
+               config_get_bool doth "$vif" 80211h
+               [ -n "$doth" ] && iwpriv "$ifname" doth "$doth"
+
+               config_get_bool comp "$vif" compression
+               [ -n "$comp" ] && iwpriv "$ifname" compression "$comp"
+
+               config_get_bool burst "$vif" bursting
+               [ -n "$burst" ] && iwpriv "$ifname" burst "$burst"
+
+               config_get_bool wmm "$vif" wmm
+               [ -n "$wmm" ] && iwpriv "$ifname" wmm "$wmm"
+
+               config_get_bool xr "$vif" xr
+               [ -n "$xr" ] && iwpriv "$ifname" xr "$xr"
+
+               config_get_bool ar "$vif" ar
+               [ -n "$ar" ] && iwpriv "$ifname" ar "$ar"
+
+               config_get_bool turbo "$vif" turbo
+               [ -n "$turbo" ] && iwpriv "$ifname" turbo "$turbo"
+
+               config_get maclist "$vif" maclist
+               [ -n "$maclist" ] && {
+                       # flush MAC list
+                       iwpriv "$ifname" maccmd 3
+                       for mac in $maclist; do
+                               iwpriv "$ifname" addmac "$mac"
+                       done
+               }
+
+               config_get macpolicy "$vif" macpolicy
+               case "$macpolicy" in
+                       allow)
+                               iwpriv "$ifname" maccmd 1
+                       ;;
+                       deny)
+                               iwpriv "$ifname" maccmd 2
+                       ;;
+                       *)
+                               # default deny policy if mac list exists
+                               [ -n "$maclist" ] && iwpriv "$ifname" maccmd 2
+                       ;;
+               esac
+
+               ifconfig "$ifname" up
+               iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null 
+
                local net_cfg bridge
                net_cfg="$(find_net_config "$vif")"
                [ -z "$net_cfg" ] || {
                        bridge="$(bridge_interface "$net_cfg")"
-                       append if_up "start_net '$ifname' '$net_cfg'" ";$N"
+                       config_set "$vif" bridge "$bridge"
+                       start_net "$ifname" "$net_cfg"
                }
-               # TODO: start hostapd
+               iwconfig "$ifname" essid "$ssid"
+               set_wifi_up "$vif" "$ifname"
+               case "$mode" in
+                       ap)
+                               config_get_bool isolate "$vif" isolate 0
+                               iwpriv "$ifname" ap_bridge "$((isolate^1))"
+
+                               if eval "type hostapd_setup_vif" 2>/dev/null >/dev/null; then
+                                       hostapd_setup_vif "$vif" madwifi || {
+                                               echo "enable_atheros($device): Failed to set up wpa for interface $ifname" >&2
+                                               # make sure this wifi interface won't accidentally stay open without encryption
+                                               ifconfig "$ifname" down
+                                               wlanconfig "$ifname" destroy
+                                               continue
+                                       }
+                               fi
+                       ;;
+                       wds|sta)
+                               case "$enc" in 
+                                       PSK|psk|PSK2|psk2)
+                                               case "$enc" in
+                                                       PSK|psk)
+                                                               proto='proto=WPA'
+                                                               passphrase="${key}"
+                                                               ;;
+                                                       PSK2|psk2)
+                                                               proto='proto=RSN'
+                                                               passphrase=`wpa_passphrase ${ssid} "${key}" | grep psk | grep -v \#| cut -d= -f2`
+                                                               ;;
+                                               esac
+                                               
+                                               cat > /var/run/wpa_supplicant-$ifname.conf <<EOF
+ctrl_interface=/var/run/wpa_supplicant
+network={
+       scan_ssid=1
+       ssid="$ssid"
+       key_mgmt=WPA-PSK
+       $proto
+       psk="$passphrase"
+}
+EOF
+                                       ;;
+                                       WPA|wpa|WPA2|wpa2)
+                                               #add wpa_supplicant calls here
+                                       ;;
+                               esac
+                               [ -z "$proto" ] || wpa_supplicant ${bridge:+ -b $bridge} -B -D wext -i "$ifname" -c /var/run/wpa_supplicant-$ifname.conf
+                       ;;
+               esac
+               first=0
        done
-       
-       #killall -KILL $hostapd >&- 2>&-
-       eval "$if_up"
 }
 
 
 detect_atheros() {
        cd /proc/sys/dev
        [ -d ath ] || return
-       for dev in wifi*; do
+       for dev in $(ls -d wifi* 2>&-); do
                config_get type "$dev" type
                [ "$type" = atheros ] && return
                cat <<EOF
@@ -134,14 +308,15 @@ config wifi-device  $dev
        option type     atheros
        option channel  5
 
+       # REMOVE THIS LINE TO ENABLE WIFI:
+       option disabled 1
+
 config wifi-iface
-       option device   $dev
-       option mode     ap
-       option ssid     OpenWrt
-       option hidden   0
+       option device   $dev
+       option network  lan
+       option mode     ap
+       option ssid     OpenWrt
        option encryption none
-
 EOF
        done
 }
-